{% extends 'base.html.twig' %}

{% block title %}Edit Author{% endblock %}

{% block body %}
    <h1>Edit Author</h1>
    <input type="hidden" id="get-books-path" value="{{ path('books_all', {'authorId': author.id }) }}">
    {{ include('author/_form.html.twig', {'button_label': 'Update'}) }}
    <a href="{{ path('author_index') }}">back to list</a>
    {{ include('author/_delete_form.html.twig') }}
    <div id="message" class="alert alert-danger col-md-12"></div>
    <table class="table text-center">
        <thead>
        <tr class="d-flex">
            <th scope="col" class="col-1 text-center">Id</th>
            <th scope="col" class="col-9 text-center">Title</th>
            <th scope="col" class="col-2 text-center">actions</th>
        </tr>
        </thead>
        <tbody>
        {% for book in books %}
            <tr class="d-flex">
                <td class="col-1">{{ book.id }}</td>
                <td class="col-9">{{ book.title }}</td>
                <td class="col-2">
                    <a class="btn btn-danger remove__book" href="#"
                       data-path="{{ path('remove_book', {'id': author.id,'bookId': book.id}) }}"
                    >delete</a>
                </td>
            </tr>
        {% else %}
            <tr>
                <td colspan="3">no records found</td>
            </tr>
        {% endfor %}
        </tbody>
    </table>
    <div class="navigation d-flex justify-content-center">
        {{ knp_pagination_render(books) }}
    </div>
{% endblock %}
{% block javascripts %}
    <script type="text/javascript" src="{{ asset('js/select2-search-books.js') }}"></script>
    <script type="text/javascript">
        const message = $(document).find('#message');
        const btn = $(document).find('.remove__book');
        message.hide();
        $(document).ready(function () {
            btn.click(function (e) {
                e.preventDefault();
                $.ajax({
                    url: $(this).data('path'),
                    method: "DELETE",
                    beforeSend: function (xhr, opts) {
                        message.empty();
                        message.hide();
                    },
                    success: function (response) {
                        location.reload();
                    },
                    error: function (jqXHR, status) {
                        message.show();
                        try {
                            const data = jQuery.parseJSON(jqXHR.responseText);
                            if (jqXHR.status === 400 && data.message) {
                                message.append(data.message)
                            }
                        } catch (e) {
                            message.append('System error')
                        }
                    }
                });
            });
        });
    </script>
{% endblock %}